/*
	㭪 StringID - ᢮稢 ப  ᭮
 ᨬ쭮 ࠧ ᨬ  ⮬ ⮫쪮 ᮣ 㪢.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define _TRUE   1
#define _FALSE  0

#define IsLower(c)      ((c)<0177?islower(c):(char)(((c)>=''&&(c)<='')||\
                        ((c)>=''&&(c)<='')?1:0))
#define IsUpper(c)      ((c)<0177?isupper(c):(char)((c)>=''&&(c)<=''?1:0))
#define ToUpper(c)      ((c)<0177?toupper(c):(char)(!IsLower(c)?(c):\
                        (c)<=''?((c)-''+''):((c)-''+'')))
#define IsPrintable(c)  ((c)>=' '&&(c)!=0177&&(c)!=0377)
#define IsRussian(c)    (((c)>=''&&(c)<='')||((c)>=''&&(c)<=''))
#define IsEnglish(c)     isalpha((c))
#define IsDigit(c)       isdigit((c))
#define IsControl(c)     iscntrl((c))
#define IsPunctuation(c) ispunct((c))
#define IsGraphics(c)    (((c)>=''&&(c)<='')||((c)>=240&&(c)<=''))
#define IsAlpha(c)       (IsRussian(c)||IsEnglish(c))



/*      ᮪ ᮣ ᪮  ⨭᪮ 䠢⮢ (࠭   )	*/
static  char    ABCons [] = "PQBRCSDTFVGWHXZKLMN0123456789";
static  int     TotalCons = 0;          // ᥣ ᮣ

static  int     CharCmp ( char *F, char *S )
{                                       // 㭪 ࠢ  ᨬ
return ( (int)(*F)-(*S) );
}


static  int     IsABCons ( char C )     // 㭪 ஢ 㪢 - ᭠
{                                       //  ᮣ᭠ ?
C = (char)ToUpper((int)C);              // ᨬ  孨 ॣ
return(bsearch(&C,ABCons,TotalCons,sizeof(C),CharCmp)==NULL?_FALSE:_TRUE);
}


long    StringID ( char *S )
{
	char    cmin, cmax;
	register int i;
	unsigned long  ID;
	unsigned long  Weight;

if ( TotalCons == 0 )                   // ᫨ ᮣ   ⠭,
    {                                   //     ஢
    TotalCons = strlen(ABCons);         // ᥣ ᮣ
    qsort(ABCons,TotalCons,sizeof(ABCons[0]),CharCmp);// 㥬
    }
for ( i = 0, cmin = cmax = S [0]; S [i]; i++ )
    {                                   // 饬   㪢
    if ( IsABCons(S[i]) )               // 祬   ⮫쪮 
	{                               // ᮣ
	cmin = min(S [i],cmin);
	cmax = max(S [i],cmax);
	}
    }                                   //  ⥯ 塞 ID ।
for ( Weight = 1l, ID = 0l, i = 0; S [i]; i++ )
    {					// ய᪠  㪢
    if ( IsABCons(S[i]) )               //  , 뢠 ⮫쪮
	{                               // ᮣ 㪢
	ID += (unsigned long)(S [i]-cmin+1)*Weight;
	Weight += (unsigned long)(cmax-cmin);
	}
    }
return ( ID ? ID : ID+1l );		// ID     ࠢ 0
}
