#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "popusers.h"


static char *stdNames [2] = {
    "postmaster",
    "root"
    };
static int totalStdNames = 2;

int  addStandardNames ( NwUser **pu, int *ptotal )
{
      register int i;

errno = 0;
if ( *pu == NULL )
    {
    *pu = (NwUser *)malloc(sizeof(NwUser));
    *ptotal = 0;
    }
for ( i = 0; *pu != NULL && i < totalStdNames; i++ )
    {
    qsort ( *pu, *ptotal, sizeof(NwUser), strcmp );
    if ( bsearch(stdNames[i],*pu,*ptotal,sizeof(NwUser),strcmp) == NULL )
        {       // user does not found
        strcpy ( (*pu)[*ptotal].user_name, stdNames [i] );
        strcpy ( (*pu)[*ptotal].full_name, stdNames [i] );
        ++(*ptotal);
        if ( (*pu=(NwUser *)realloc(*pu,sizeof(NwUser)*(*ptotal+1))) == NULL )
            break;
        }
    }
return ( errno );
}
