#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "popusers.h"

static char copiright [] = "(C) Andy A. Porro (porro@cbs-edu.chel.su) "
                               "Mike A. Potapoff (mike@cbs-edu.chel.su) 1999.";

PopUser  *PopUserTable;
int      PopUserTotal;
NwUser   *NwUserTable;
int      NwUserTotal;
char     popUserFile [] = "UserInfo\\OS2POPS.Users";
char     *OS2POPS = popUserFile;
char     netwareUserFile [] = "Work\\nwusers";
char     *NWUSERS = netwareUserFile;
char     foldersBase [] = "MailRoot";
char     *BASE = foldersBase;


int   main ( int argc, char *argv[] )
{
    register int i;


for ( i = 1; i < argc; i++ )
    {
    switch ( i )
        {
    case 1:
        OS2POPS = argv[i];
        break;
    case 2:
        NWUSERS = argv[i];
        break;
    case 3:
        BASE = argv[i];
        break;
    default:
        break;
        }
    }
PopUserTotal = getPopUsers ( OS2POPS );
NwUserTotal = getNwUsers ( NWUSERS );
if ( NwUserTotal > 2 )
    {
    addStandardNames ( &NwUserTable, &NwUserTotal );
    writePopUserFile ( OS2POPS, NwUserTable, NwUserTotal );
    delPopUsers ( BASE, PopUserTable, PopUserTotal, NwUserTable, NwUserTotal );
    makePopUsersFolders ( BASE, NwUserTable, NwUserTotal );
    }
free ( PopUserTable );
free ( NwUserTable );
return ( 0 );
}
