#ifndef _OS2POPS

#define _OS2POPS

#define _MAX_USER_NAME     15
#define _MAX_FULL_NAME     63
#define _MAX_USER_PASSWORD 15
#define _MAX_PASSWORDS     64

typedef struct _PopUser {
    char  user_name [_MAX_USER_NAME+1];
    char  password  [_MAX_USER_PASSWORD+1];
    char  full_name [_MAX_FULL_NAME+1];
    }  PopUser;

typedef struct _NwUser {
    char  user_name [_MAX_USER_NAME+1];
    char  full_name [_MAX_FULL_NAME+1];
    }  NwUser;


extern PopUser  *PopUserTable;
extern int      PopUserTotal;
extern NwUser   *NwUserTable;
extern int      NwUserTotal;

int    getPopUsers ( char ufname[] );
int    getNwUsers ( char ufname[] );
int    writePopUserFile ( char ufname[], NwUser pu[], int total );
int    makePopUsersFolders ( char *base, NwUser *pu, int total );
int    eraseFolder ( char folder[] );
int    delPopUsers ( char *base, PopUser *ppu, int ptotal, NwUser *pnu, int ntotal );
int    addStandardNames ( NwUser **pu, int *ptotal );
char   *getUserPassword ( char *fullName );
long   StringID ( char *str );

#endif